#include <stdio.h>
#include <stdlib.h>

int **alloca_matrice (int m, int n)
{
	int i;

	int *elems = malloc(sizeof(int)*m*n);
	int **a = malloc(sizeof(int *) * m);
	if (elems == NULL || a == NULL) {
		printf("malloc() failed\n");
		exit(2);
	}

	for (i=0; i<m; i++) {
		a[i] = elems + n*i;
	}

	return a;
}

int *alloca_vettore (int n)
{
	int *v = malloc(sizeof(int)*n);
	if (v == NULL) {
		printf("malloc() failed\n");
		exit(2);
	}

	return v;
}

void stampa_m (int **m, int nr, int nc)
{
	int i,j;

	for (i=0; i<nr; i++) {
		for (j=0; j<nc; j++) {
			printf("%d ", m[i][j]);
		}
		printf("\n");
	}
	printf("---\n");
}

void stampa_v (int *v, int n)
{
	int i;

	for (i=0; i<n; i++) {
		printf("%d\n", v[i]);
	}
	printf("---\n");
}


int f (int **A, int m, int n, int *v, int dim_v)
{
	if (m != dim_v)
		return -1;

	int elementi_maggiori = 0;
	int i,j;

	for (i=0; i<m; i++) {
		for (j=0; j<n; j++) {
			if (A[i][j] >= v[i]) {
				elementi_maggiori++;
			} else {
				A[i][j] = 0;
			}
		}
	}

	return elementi_maggiori;
}


int main()
{
	int M = 4;
	int N = 3;

	int i,j;

	int **A = alloca_matrice(M,N);
	/* Inizializza gli elementi... */
	for (i=0; i<M; i++) {
		for (j=0; j<N; j++) {
			A[i][j] = 2.0*(M-i+1)-j; // TODO
		}
	}
	stampa_m(A, M, N);

	int *v = alloca_vettore(M);
	/* Inizializza gli elementi... */
	for (i=0; i<M; i++) {
		v[i] = 2*i+2; // TODO
	}
	stampa_v(v, M);

	int ret = f(A, M, N, v, M);
	printf("Valore restituito: %d\n", ret);

	stampa_m(A, M, N);

	free(A[0]);
	free(A);

	return 0;
}
