#include <stdio.h>

#define M 2
#define N 3

int confronta_riga_colonna (int a[M][N], int b[N][M], int riga, int col)
{
	int i;
	int uguali=1;
	for (i=0; i<N; ++i) {
		uguali &= (a[riga][i] == b[i][col]);
	}
	return uguali;
}

int confronta_riga_vettore (int a[M][N], int vettore[N], int riga)
{
	int i;
	int uguali=1;
	for (i=0; i<N; ++i) {
		uguali &= (a[riga][i] == vettore[i]);
	}
	return uguali;
}

void somma_colonne (int b[N][M], int vettore[N], int col1, int col2)
{
	int i;	
	for (i=0; i<N; ++i) {
		vettore[i] = b[i][col1] + b[i][col2];
	}
}

int verifica_riga (int a[M][N], int b[N][M], int riga)
{
	int j,k;
	int trovata = 0;

	/* Verifica se esiste una colonna di B uguale alla riga */
	for (j=0; j<M && !trovata; ++j) {
		if (confronta_riga_colonna(a,b,riga,j)) {
			trovata=1;
			printf("Riga %d di A uguale a colonna %d di B\n", riga, j);
		}
	}


	/* Verifica se la riga e' ottenibile come somma di due colonne */
	for (j=0; j<M && !trovata; ++j) {
		for (k=j+1; k<M && !trovata; ++k) {
			int nuova_colonna[N];
			somma_colonne(b,nuova_colonna,j,k);
			if (confronta_riga_vettore(a,nuova_colonna,riga)) {
				trovata=1;
				printf("Riga %d di A uguale a somma colonne %d-%d di B\n", riga, j, k);
			}
		}
	}

	return trovata;
}

int verifica (int a[M][N], int b[N][M])
{
	int i;

	for (i=0; i<M; ++i) {
		if (!verifica_riga(a, b, i))
			return 0;
	}

	return 1;
}

int main()
{
	int A[M][N] = { {1, 5, 4},
	       	        {1, 6, 11} };
	int B[N][M] = { {1, 0},
	       	        {5, 1},
			{4, 7} };

	int ok = verifica(A,B);
	printf("%s\n", ok? "Vero" : "Falso");

	return 0;
}
